// TODO: unit tests

var asyncQueueImproved = require('./index')

var q = asyncQueueImproved(function(task, callback) {
  console.log('working on %j', task)

  setTimeout(function() {
    console.log('done working on %j', task)
    callback(task.fakeError, task.fakeResult)
  }, task.duration)
}, 5)

var taskCallback = function(err, result) {
  if (err) {
    return console.error(err.stack || err)
  }
  else {
    return console.log("Result: %j", result)
  }
}

q.push({id: 1, data:{fakeError: null, fakeResult:111, duration: 100}, timeout: 1000}, taskCallback)
q.push({id: 1, data:{fakeError: null, fakeResult:112, duration: 100}, timeout: 1000}, taskCallback)
q.push({id: 1, data:{fakeError: null, fakeResult:113, duration: 100}, timeout: 1000}, taskCallback)

setTimeout(function() {
  q.push({id: 2, data:{fakeError: "hehe", fakeResult:114, duration: 100}, timeout: 1000}, taskCallback)
}, 100)

q.onComplete(function(err) {
  console.log('queue complete!')
  if (err) {
    console.log('(errors %j)', err.length)
  }
})
